// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// Rounding up for integer
//
// Calling Sequence :
// ceil(a)
//
// Arguments :
// a : DD number
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// make this file : 2011/08/31
// last updating : 2011/08/31
// *****************************************************************
function ans = %dd_ceil(a)
  [m,n] = size(a.hi);
  hi = ceil(a.hi);
  lo = zeros(m,n);
  ans = tlist(['dd','hi','lo'],hi,lo);
  if(hi == a.hi) then
    // High word is integer already.  Round the low word.
    // Based on Bailey's QD, dd_real ceil
    lo = ceil(a.lo);
    ans.hi = hi + lo;
    ans.lo = lo - (ans.hi - hi);
  end    
endfunction

