// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// Cosine function for DD
//
// Calling Sequence :
// cos(x)
//
// Arguments :
// x : DD number
// 
// This function is based on Bailey's QD, dd_real cos
// http://crd.lbl.gov/~dhbailey/mpdist/
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// make this file : 2011/09/02
// last updating : 2012/02/03
// *****************************************************************
function c = %dd_cos(x)
      [chi,clo] = call('ddcos',x.hi,3,'d',x.lo,4,'d','out',[1,1],1,'d',[1,1],2,'d');
    c = tlist(['dd','hi','lo'],chi,clo);
endfunction

