// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// LU decomposition
//
// Calling Sequence :
// lu(A)
//
// Arguments :
// A : DD matrix
//
// Return :
// L : (n,n) lower triangular matrix
// U : (n,n) upper triangular matrix
//
// make dll file with Visual C++2010
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// last updating : 2011/08/31
// *****************************************************************
function [L,U] = %dd_lu(A)
  [m,n] = size(A.hi)
  if m~=n then
    disp('A is not square matrix.')
  else
    [Lhi,Llo,Uhi,Ulo] = call('ddlu',A.hi,5,'d',A.lo,6,'d',n,7,'i','out',[m,n],1,'d',[m,n],2,'d',[m,n],3,'d',[m,n],4,'d');
    L = tlist(['dd','hi','lo'],Lhi,Llo);
    U = tlist(['dd','hi','lo'],Uhi,Ulo);
  end
endfunction
