// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// DD multiplication (dd * double)
//
// Calling Sequence :
// a * b
//
// a(i,j) (in Scilab) = a[m*j+i] (in C++)
// make dll file with Visual C++2010
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// last updating : 2011/04/20 
// *****************************************************************
function c = %dd_m_s(a,b)
  [m1,n1] = size(a.hi);
  [m2,n2] = size(b);
  if(m1 == 1 & n1 == 1) then
   // if scalar * (vector or matrix)
    // mix_scalar_multi_1 is the dedicated routine for computing product that scalar is dd number
    [c,cc]=call('mix_scalar_multi_1',a.hi,3,'d',a.lo,4,'d',b,5,'d',m2,6,'i',n2,7,'i','out',[m2,n2],1,'d',[m2,n2],2,'d');
    c = tlist(['dd','hi','lo'],c,cc);
  elseif(m2 == 1 & n2 == 1) then
    // if (vector or matrix) * scalar
    // mix_scalar_multi_2 is the dedicated routine for computing product that vector (or matrix) is dd number
    [c,cc] = call('mix_scalar_multi_2',b,3,'d',a.hi,4,'d',a.lo,5,'d',m1,6,'i',n1,7,'i','out',[m1,n1],1,'d',[m1,n1],2,'d');
    c = tlist(['dd','hi','lo'],c,cc);
  elseif (n1 ~= m2) then 
    error(10)   //Inconsistent multiplication.
    abort;
  else
    [c,cc]=call('dd_m_s',a.hi,3,'d',a.lo,4,'d',b,5,'d',m1,6,'i',n2,7,'i',n1,8,'i','out',[m1,n2],1,'d',[m1,n2],2,'d');
    c = tlist(['dd','hi','lo'],c,cc);
  end
endfunction

