// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// Vector norm of DD number
//
// Calling Sequence :
// norm(x,N)
//
// Arguments :
// x : DD vector
// N : 1 or 2 or %inf
//
// make dll file with Visual C++2010 (ddsum, ddnorm_two)
//
// ***TODO : apply for matrix
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// last updating : 2011/04/21
// *****************************************************************
function z = %dd_norm(x,N)
  [m,n] = size(x.hi);
  if n ~= 1 then
    disp('Error : input number is not vector.');
  else
  select N
    case 1 // 1-norm
      b = x;
      c = find(sign(b.hi)==-1);
      b.hi(c) = (-1)*b.hi(c);
      b.lo(c) = (-1)*b.lo(c);
      z = call('ddsum',x.hi,2,'d',x.lo,3,'d',m,4,'i',n,5,'i','out',[2,1],1,'d'); //...ɒӁi{\[gׂj
      z = tlist(['dd','hi','lo'],z(1),z(2));
    case 2 // 2-norm
      if(x == tlist(['dd','hi','lo'],zeros(m,1),zeros(m,1))) then
        z = tlist(['dd','hi','lo'],0,0);
      else
        z = call('ddnorm_two',x.hi,2,'d',x.lo,3,'d',m,4,'i','out',[2,1],1,'d');
        z = tlist(['dd','hi','lo'],z(1),z(2));
      end
    case %inf // -norm
      z = x;
      c = find(sign(z.hi)==-1);
      z.hi(c) = (-1)*z.hi(c);
      z.lo(c) = (-1)*z.lo(c);
      x_max = z(1,1)
      for i=2:m
        if(z(i,1) > x_max)
          x_max = z(i,1);
        end
      end
      z = x_max;
    else
      disp('n is not 1 or 2 or %inf')
      z = tlist(['dd','hi','lo'],0,0);
    end
  end
endfunction
