// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// Square root of DD numbers
//
// Calling Sequence :
// sqrt(a)
//
// Arguments :
// a : DD matrix
//
// make dll file with Visual C++2010
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// last updating : 2011/08/23
// *****************************************************************
function sq = %dd_sqrt(a)
  [m,n] = size(a.hi);
  O = zeros(m,n);
  if(find(a.hi<O) == []) then  // check whether argument have a negative number or not
    [c,cc] = call('ddsqrt',a.hi,3,'d',a.lo,4,'d',m,5,'i',n,6,'i','out',[m,n],1,'d',[m,n],2,'d');
    sq = tlist(['dd','hi','lo'],c,cc);
  elseif(a.hi == O & a.lo == O)
    sq = tlist(['dd','hi','lo'],O,O);
  else
    sq = tlist(['dd','hi','lo'],%nan,%nan);     //if argument includes a negative number
    disp('Error:argument is invalid value');
  end
endfunction

