// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// Cosine function for QD
//
// Calling Sequence :
// cos(x)
//
// Arguments :
// x : QD number
// 
// This function is based on Bailey's QD, qd_real cos
// http://crd.lbl.gov/~dhbailey/mpdist/
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// make this file : 2011/09/03
// last updating : 2012/02/03
// *****************************************************************
function c = %qd_cos(x)
      [c1,c2,c3,c4] = call('qdcos',x(2),5,'d',x(3),6,'d',x(4),7,'d',x(5),8,'d','out',[1,1],1,'d',[1,1],2,'d',[1,1],3,'d',[1,1],4,'d');
    c = tlist(['qd','d'],c1,c2,c3,c4);
endfunction
