// ====================================================================
// Copyright (C) 2012 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// exponent for QD
//
// Calling Sequence :
// exp(x)
//
// Arguments :
// x : QD number
// 
// This function is based on Bailey's QD, qd_real exp
// http://crd.lbl.gov/~dhbailey/mpdist/
//
// Authors :
// Copyright (C) 2012 - Tsubasa Saito
// make this file : 2012/03/09
// last updating : 2012/03/09
// *****************************************************************
function s = %qd_exp(x)
      [s0,s1,s2,s3] = call('qdexp',x(2),5,'d',x(3),6,'d',x(4),7,'d',x(5),8,'d','out',[1,1],1,'d',[1,1],2,'d',[1,1],3,'d',[1,1],4,'d');
    s = tlist(['qd','d'],s0,s1,s2,s3);
endfunction
