// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// Rounding down for integer
//
// Calling Sequence :
// floor(a)
//
// Arguments :
// a : QD number
// 
// This function is based on Bailey's QD, qd_real floor
// http://crd.lbl.gov/~dhbailey/mpdist/
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// make this file : 2011/08/31
// last updating : 2011/09/01
// *****************************************************************
function b= %qd_floor(a)
  [m,n] = size(a.d);
  O = zeros(m,n);
  b = tlist(['qd','d'],floor(a.d),O,O,O);
  c = find(a(2) == floor(a(2)));
  if(c ~= []) then
    b(3)(c) = floor(a(3)(c));
    c = find(a(3) == floor(a(3)));
    if(c ~= []) then
      b(4)(c) = floor(a(4)(c));
      c = find(a(4) == floor(a(4)));
      if(c ~= []) then
        b(5)(c) = floor(a(5)(c));
      end
    end
    [b(2),b(3),b(4),b(5)] = renormalize(b(2),b(3),b(4),b(5),O);
  end 
endfunction

