// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// LU decomposition
//
// Calling Sequence :
// lu(A)
//
// Arguments :
// A : QD matrix
//
// Return :
// L : (n,n) lower triangular matrix
// U : (n,n) upper triangular matrix
//
// make dll file with Visual C++2010
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// last updating : 2011/08/31
// *****************************************************************
function [L,U] = %qd_lu(A)
  [m,n] = size(A.d)
  if (m~=n) then
    disp('A is not square matrix.')
  else
    [L1,L2,L3,L4,U1,U2,U3,U4] = call('qdlu',A(2),9,'d',A(3),10,'d',A(4),11,'d',A(5),12,'d',n,13,'i',...
    'out',[m,n],1,'d',[m,n],2,'d',[m,n],3,'d',[m,n],4,'d',[m,n],5,'d',[m,n],6,'d',[m,n],7,'d',[m,n],8,'d');
    L = tlist(['qd','d'],L1,L2,L3,L4);
    U = tlist(['qd','d'],U1,U2,U3,U4);
  end
endfunction

