// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// QD multiplication (qd * qd)
//
// Calling Sequence :
// a * b
//
// a(i,j) (in Scilab) = a[m*j+i] (in C++)
// make dll file with Visual C++2010
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// make this file : 2011/05/19 
// last updating : 2011/05/31 
// *****************************************************************
function c = %qd_m_qd(a,b)
  [m1,n1] = size(a.d);
  [m2,n2] = size(b.d);
  if(m1 == 1 & n1 == 1) then
    // if scalar * (vector or matrix)
    // scalar_multi_qd computing product including scalar
    [c1,c2,c3,c4] = call('scalar_multi_qd',a(2),5,'d',a(3),6,'d',a(4),7,'d',a(5),8,'d',b(2),9,'d',b(3),10,'d',b(4),11,'d',b(5),12,'d',m2,13,'i',n2,14,'i','out',[m2,n2],1,'d',[m2,n2],2,'d',[m2,n2],3,'d',[m2,n2],4,'d');
    c = tlist(['qd','d'],c1,c2,c3,c4);
  elseif(m2 == 1 & n2 == 1) then
    // if (vector or matrix) * scalar
    [c1,c2,c3,c4] = call('scalar_multi_qd',b(2),5,'d',b(3),6,'d',b(4),7,'d',b(5),8,'d',a(2),9,'d',a(3),10,'d',a(4),11,'d',a(5),12,'d',m1,13,'i',n1,14,'i','out',[m1,n1],1,'d',[m1,n1],2,'d',[m1,n1],3,'d',[m1,n1],4,'d');
    c = tlist(['qd','d'],c1,c2,c3,c4);
  elseif (n1 ~= m2) then 
    error(10)   //Inconsistent multiplication.
    abort;
  else
    [c1,c2,c3,c4] = call('qd_m_qd',a(2),5,'d',a(3),6,'d',a(4),7,'d',a(5),8,'d',b(2),9,'d',b(3),10,'d',b(4),11,'d',b(5),12,'d',m1,13,'i',n2,14,'i',m2,15,'i','out',[m1,n2],1,'d',[m1,n2],2,'d',[m1,n2],3,'d',[m1,n2],4,'d');
    c = tlist(['qd','d'],c1,c2,c3,c4);
  end
endfunction

