// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// Vector norm of QD number
//
// Calling Sequence :
// norm(x,.N)
//
// Arguments :
// x : QD vector
// N : 1 or 2 or %inf
//
// make dll file with Visual C++2010 (qdsum, qdnorm_two)
//
// ***TODO : apply for matrix
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// last updating : 2011/06/01
// *****************************************************************
function z = %qd_norm(x,N)
  [m,n] = size(x.d);
  if n ~= 1 then
    disp('Error : input number is not vector.');
  else
  select N
    case 1 // 1-norm
      b = x;
      c = find(sign(b.d)==-1);
      b(2)(c) = (-1)*b(2)(c);
      b(3)(c) = (-1)*b(3)(c);
      b(4)(c) = (-1)*b(4)(c);
      b(5)(c) = (-1)*b(5)(c);
      z = call('qdsum',x(2),2,'d',x(3),3,'d',x(4),4,'d',x(5),5,'d',m,6,'i',n,7,'i','out',[4,1],1,'d');
      z = tlist(['qd','d'],z(1),z(2),z(3),z(4));
    case 2 // 2-norm
      if(x == tlist(['qd','d'],zeros(m,1),zeros(m,1),zeros(m,1),zeros(m,1))) then
        z = tlist(['dd','hi','lo'],0,0,0,0);
      else
        z = call('qdnorm_two',x(2),2,'d',x(3),3,'d',x(4),4,'d',x(5),5,'d',m,6,'i','out',[4,1],1,'d');
        z = tlist(['qd','d'],z(1),z(2),z(3),z(4));
      end
    case %inf  // -norm
      z = x;
      c = find(sign(z(2))==-1);
      z(2)(c) = (-1)*z(2)(c);
      z(3)(c) = (-1)*z(3)(c);
      z(4)(c) = (-1)*z(4)(c);
      z(5)(c) = (-1)*z(5)(c);
      x_max = z(1,1)
      for i=2:m
        if(z(i,1) > x_max)
          x_max = z(i,1);
        end
      end
      z = x_max;
    else
      disp('n is not 1 or 2 or %inf')
      z = tlist(['qd','d'],0,0,0,0);
    end
  end
endfunction

