// ====================================================================
// Copyright (C) 2011 - Satoko Kikkawa
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// N-th power of QD numbers
//
// Calling Sequence :
// a^n
//
// Arguments :
// a : qd
//
// Authors :
// Copyright (C) 2011 - Satoko Kikkawa
// make this file : 2011/07/29
// last updating : 2011/07/29
// *****************************************************************
function p = %qd_p_s(a,n)
 if (n == 0) then
    p = 1.0;
  else
    r = a;   // odd-case multiplier
    p = tlist(['qd','d'],1,0,0,0);
    N = abs(n);
    
    if (N > 1)  then
      // Use binary exponentiation. 
      while (N > 0) 
        if (modulo(N,2) == 1)  then
        // If odd, multiply by r. Note eventually N = 1, so this  eventually executes. */
          p = p*r;
        end
        N = int(N/2);
        if (N > 0) then
          r = r*r;
        end
      end
    else
      p = r;
    end
    if (n < 0)
      p = 1.0 / p;
    end
  end
endfunction
