// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// Sine function for QD
//
// Calling Sequence :
// sin(x)
//
// Arguments :
// x : QD number
// 
// This function is based on Bailey's QD, qd_real sin
// http://crd.lbl.gov/~dhbailey/mpdist/
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// make this file : 2011/09/02
// last updating : 2012/02/03
// *****************************************************************
function s = %qd_sin(x)
      [s1,s2,s3,s4] = call('qdsin',x(2),5,'d',x(3),6,'d',x(4),7,'d',x(5),8,'d','out',[1,1],1,'d',[1,1],2,'d',[1,1],3,'d',[1,1],4,'d');
    s = tlist(['qd','d'],s1,s2,s3,s4);
endfunction
