// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// Square root of QD numbers
//
// Calling Sequence :
// sqrt(a)
//
// Arguments :
// a : QD matrix
//
// make dll file with Visual C++2010
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// make this file 2011/06/01
// last updating : 2011/08/02
// *****************************************************************
function sq = %qd_sqrt(a)
  [m,n] = size(a.d);
  O = zeros(m,n);
  if(find(a(2)<O) == []) then  // check whether argument have a negative number or not
    [c1,c2,c3,c4] = call('qdsqrt',a(2),5,'d',a(3),6,'d',a(4),7,'d',a(5),8,'d',m,9,'i',n,10,'i','out',[m,n],1,'d',[m,n],2,'d',[m,n],3,'d',[m,n],4,'d');
    sq = tlist(['qd','d'],c1,c2,c3,c4);
  elseif(a(2) == O & a(3) == O & a(4) ==  O & a(5) == O)
    sq = tlist(['qd','d'],O,O,O,O);
  else
    sq = tlist(['qd','d'],%nan,%nan,%nan,%nan);     //if argument includes a negative number
    disp('Error:argument is invalid value');
  end
endfunction

