// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// QD multiplication (double * qd)
//
// Calling Sequence :
// a * b
//
// a(i,j) (in Scilab) = a[m*j+i] (in C++)
// make dll file with Visual C++2010
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// make this file : 2011/05/17 
// last updating : 2011/08/02 
// *****************************************************************
function c = %s_m_qd(a,b)
  [m1,n1] = size(a);
  [m2,n2] = size(b.d);
  if(m1 == 1 & n1 == 1) then
    // if scalar * (vector or matrix)
    // ''qd_d_scalar_multi_2'' computing product including scalar
    [c1,c2,c3,c4] = call('qd_d_scalar_multi_2',b(2),5,'d',b(3),6,'d',b(4),7,'d',b(5),8,'d',a,9,'d',m2,10,'i',n2,11,'i','out',[m2,n2],1,'d',[m2,n2],2,'d',[m2,n2],3,'d',[m2,n2],4,'d');
    c = tlist(['qd','d'],c1,c2,c3,c4);
  elseif(m2 == 1 & n2 == 1) then
    // if (vector or matrix) * scalar
    // ''qd_d_scalar_multi_1'' computing product including scalar
    [c1,c2,c3,c4] = call('qd_d_scalar_multi_1',b(2),5,'d',b(3),6,'d',b(4),7,'d',b(5),8,'d',a,9,'d',m1,10,'i',n1,11,'i','out',[m1,n1],1,'d',[m1,n1],2,'d',[m1,n1],3,'d',[m1,n1],4,'d');
    c = tlist(['qd','d'],c1,c2,c3,c4);
  elseif (n1 ~= m2) then 
    error(10)   // Inconsistent multiplication.
    abort;
  else
    [c1,c2,c3,c4] = call('s_m_qd',a,5,'d',b(2),6,'d',b(3),7,'d',b(4),8,'d',b(5),9,'d',m1,10,'i',n2,11,'i',m2,12,'i','out',[m1,n2],1,'d',[m1,n2],2,'d',[m1,n2],3,'d',[m1,n2],4,'d');
    c = tlist(['qd','d'],c1,c2,c3,c4);
  end
endfunction

