// ====================================================================
// Copyright (C) 2009-2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// definition DD value
//
// Calling Sequence :
// dd(a1,a2)
// dd(a1)
//
// Authors :
// Copyright (C) 2009-2011 - Tsubasa Saito
// make this function : 2009/11/18
// last updating : 2011/09/19
// *****************************************************************
function a = dd(varargin)
  select length(varargin)
  case 1
    [m,n] = size(varargin(1));
    O = zeros(m,n);
    a = tlist(['dd','hi','lo'],varargin(1),O);
  case 2
    if(size(varargin(1)) == size(varargin(2))) then
      s = varargin(1) + varargin(2);
      v = s - varargin(1);
      e = (varargin(1) - (s - v))+(varargin(2) - v);
      a = tlist(['dd','hi','lo'],s,e);
    else
      error(5) // Inconsistent column/row dimensions.
      abort;
    end
  else
      error(58) // Wrong number of input arguments.
      abort;
  end
endfunction
