// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// Gaussian Elimination for DD
//
// Calling Sequence :
// ddGauss(A,b)
//
// Arguments :
// A : DD matrix
// b : DD vector
//
// make dll file with Visual C++2010 (ddgauss)
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// last updating : 
// *****************************************************************
function x = ddGauss(A,b)
  [m,n] = size(A.hi);
  if(m ~= n) then
    error(1);
    abort;
  else
    [c,cc] = call('ddgauss',A.hi,3,'d',A.lo,4,'d',b.hi,5,'d',b.lo,6,'d',n,7,'i','out',[n,1],1,'d',[n,1],2,'d');
    x = tlist(['dd','hi','lo'],c,cc);
  end
endfunction

