// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// Inner product of DD numbers
//
// Calling Sequence :
// ddip(x,y)
//
// Arguments :
// x,y : DD vectors
//
// make dll file with Visual C++2010
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// last updating : 2011/04/21
// *****************************************************************
function z = ddip(x,y)
  [m1,n1] = size(x.hi);
  [m2,n2] = size(y.hi);
  if n1 ~= 1 | n2 ~=1 | m1 ~= m2 then
    disp('Error in  ddip!');
    z = tlist(['dd','hi','lo'],0,0);
  else
    c = call('ddip',x.hi,2,'d',x.lo,3,'d',y.hi,4,'d',y.lo,5,'d',m1,6,'i','out',[2,1],1,'d');
    z = tlist(['dd','hi','lo'],c(1),c(2));
  end
endfunction

