// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// Gaussian Elimination for QD
//
// Calling Sequence :
// qdGauss(A,b)
//
// Arguments :
// A : QD matrix
// b : QD vector
//
// make dll file with Visual C++2010 (ddgauss)
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// last updating : 
// *****************************************************************
function x = qdGauss(A,b)
  [m,n] = size(A.d);
  if(m ~= n) then
    error(1);
    abort;
  else
    [c0,c1,c2,c3] = call('qdgauss',A(2),5,'d',A(3),6,'d',A(4),7,'d',A(5),8,'d',b(2),9,'d',b(3),10,'d',b(4),11,'d',b(5),12,'d',n,13,'i','out',[n,1],1,'d',[n,1],2,'d',[n,1],3,'d',[n,1],4,'d');
    x = tlist(['qd','d'],c0,c1,c2,c3);
  end
endfunction

