// ====================================================================
// Copyright (C) 2011 - Tsubasa Saito
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================

// *****************************************************************
// Linker for QD arithmetic
//
// Authors :
// Copyright (C) 2011 - Tsubasa Saito
// last updating : 2011/11/01
// *****************************************************************

mode(-1)
mainpath = get_absolute_file_path('qdlink.sci');
chdir(mainpath);

linkmatrix = ['qd_a_s';'s_a_qd';'qd_a_dd';'dd_a_qd';'qd_a_qd';...
'qd_s_s';'s_s_qd';'qd_s_dd';'dd_s_qd';'qd_s_qd';...
'qd_d_scalar_multi_1';'qd_d_scalar_multi_2';'qd_m_s';'s_m_qd';...
'qd_dd_scalar_multi_1';'qd_dd_scalar_multi_2';'dd_m_qd';'qd_m_dd';...
'qd_m_qd';'scalar_multi_qd';...
'qd_r_s';'s_r_qd';'qd_r_dd';'dd_r_qd';'qd_r_qd';...
'renorm'];
ilib_for_link(linkmatrix,'qd.c',[],"c");// load the shared library
exec loader.sce;

linkmatrix = ['qdgauss';'qdlu';...
'qdip';'qdnorm_two';'qdsum'];

ilib_for_link(linkmatrix,'qd_nc.c',[],"c");// load the shared library
exec loader.sce;

linkmatrix = ['qdsqrt';'qdpow';'qdsin';'qdcos';'qdtan';'qdexp'];

ilib_for_link(linkmatrix,'qd_ef.c',[],"c");// load the shared library
exec loader.sce;

clear mainpath;
clear linkmatrix;
